package net.dries007.tapemouse;

import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.command.NumberInvalidException;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.Style;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.fml.relauncher.ReflectionHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import static org.lwjgl.input.Keyboard.KEY_NONE;

/**
 * @author Dries007
 */
@SideOnly(Side.CLIENT)
public class CommandTapeMouse extends CommandBase
{
    private static final Map<String, KeyBinding> KEYBIND_ARRAY = ReflectionHelper.getPrivateValue(KeyBinding.class, null, "KEYBIND_ARRAY", "field_74516_a");
    private boolean prevPauseSetting = true; // defaults to true

    @Override
    public String func_71517_b()
    {
        return TapeMouse.MODID.toLowerCase();
    }

    @Override
    public boolean func_184882_a(MinecraftServer server, ICommandSender sender)
    {
        return sender instanceof EntityPlayer;
    }

    @Override
    public String func_71518_a(ICommandSender sender)
    {
        return '/' + func_71517_b() + " [off|keybinding name ...] [delay] OR Use no arguments to get a list of keybindings.";
    }

    @Override
    public void func_184881_a(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException
    {
        if (args.length == 0)
        {
            sender.func_145747_a(new TextComponentString("List of keybindings").func_150255_a(new Style().func_150238_a(TextFormatting.AQUA)));
            sender.func_145747_a(new TextComponentString("Key => NAME (category)").func_150255_a(new Style().func_150238_a(TextFormatting.AQUA)));

            for (KeyBinding keyBinding : KEYBIND_ARRAY.values())
            {
                if (keyBinding == null || keyBinding.func_151463_i() == KEY_NONE) continue;
                String name = keyBinding.func_151464_g();
                if (name == null) continue;
                name = name.replaceFirst("^key\\.", "");

                String cat = keyBinding.func_151466_e();
                if (cat == null) continue;
                cat = cat.replaceFirst("^key\\.", "");
                cat = cat.replaceFirst("^categories\\.", "");

                sender.func_145747_a(new TextComponentString(keyBinding.getDisplayName() + " => " + name + " (" + cat + ")"));
            }
            return;
        }
        if (args[0].equalsIgnoreCase("off"))
        {
            Minecraft.func_71410_x().field_71474_y.field_82881_y = prevPauseSetting;
            TapeMouse.keyBinding = null;
            TapeMouse.i = 0;
            sender.func_145747_a(new TextComponentString("TapeMouse off."));
        }
        else
        {
            StringBuilder askedName = new StringBuilder(args[0]);
            if (args.length > 1)
            {
                try
                {
                    TapeMouse.delay = func_180528_a(args[args.length - 1], 0);
                    for (int i = 1; i < args.length - 1; i++) askedName.append(' ').append(args[i]);
                }
                catch (NumberInvalidException e)
                {
                    // Assume last part was not a number
                    for (int i = 1; i < args.length; i++) askedName.append(' ').append(args[i]);
                }
                askedName = new StringBuilder(askedName.toString().trim());
            }
            for (KeyBinding keyBinding : KEYBIND_ARRAY.values())
            {
                if (keyBinding == null) continue;
                String name = keyBinding.func_151464_g();
                //noinspection ConstantConditions Because of stupid mod authors...
                if (name == null) continue;
                name = name.replaceFirst("^key\\.", "");
                if (askedName.toString().equalsIgnoreCase(name))
                {
                    prevPauseSetting = Minecraft.func_71410_x().field_71474_y.field_82881_y;
                    Minecraft.func_71410_x().field_71474_y.field_82881_y = false;
                    TapeMouse.keyBinding = keyBinding;
                    sender.func_145747_a(new TextComponentString("TapeMouse on '" + name + "' (" + keyBinding.getDisplayName() + ") with delay " + TapeMouse.delay + " ticks."));
                    return;
                }
            }

            throw new CommandException(askedName + " is unknown keybinding. If your keybind ends in a number, you *have* to specify the delay.");
        }
    }

    @Override
    public List<String> func_184883_a(MinecraftServer server, ICommandSender sender, String[] args, @Nullable BlockPos pos)
    {
        if (args.length == 1)
        {
            List<String> list = new ArrayList<>();
            list.add("off");
            for (KeyBinding keyBinding : KEYBIND_ARRAY.values())
            {
                if (keyBinding == null || keyBinding.func_151463_i() == KEY_NONE) continue;
                String name = keyBinding.func_151464_g();
                //noinspection ConstantConditions Because of stupid mod authors...
                if (name == null) continue;
                name = name.replaceFirst("^key\\.", "");
                list.add(name);
            }
            return func_175762_a(args, list);
        }
        return super.func_184883_a(server, sender, args, pos);
    }
}
